=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2011-12-12 13:56:17 +0000
+++ bzrlib/builtins.py	2011-12-12 14:21:56 +0000
@@ -23,6 +23,7 @@
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 import cStringIO
+import errno
 import sys
 import time
 
@@ -781,7 +782,11 @@
         for dir in dir_list:
             wt, relpath = WorkingTree.open_containing(dir)
             if parents:
-                os.makedirs(dir)
+                try:
+                    os.makedirs(dir)
+                except OSError, e:
+                    if e.errno != errno.EEXIST:
+                        raise
             else:
                 os.mkdir(dir)
             add_file(wt, relpath)

=== modified file 'bzrlib/tests/blackbox/test_mkdir.py'
--- bzrlib/tests/blackbox/test_mkdir.py	2011-12-10 21:21:31 +0000
+++ bzrlib/tests/blackbox/test_mkdir.py	2011-12-12 13:25:39 +0000
@@ -27,7 +27,6 @@
     def test_mkdir(self):
         tree = self.make_branch_and_tree('.')
         self.run_bzr(['mkdir', 'somedir'])
-
         self.assertEquals(tree.kind(tree.path2id('somedir')), "directory")
 
     def test_mkdir_multi(self):
@@ -41,6 +40,18 @@
         self.run_bzr(['mkdir', '-p', 'somedir/foo'])
         self.assertEquals(tree.kind(tree.path2id('somedir/foo')), "directory")
 
+    def test_mkdir_parents_existing_versioned_dir(self):
+        tree = self.make_branch_and_tree('.')
+        tree.mkdir('somedir')
+        self.assertEquals(tree.kind(tree.path2id('somedir')), "directory")
+        self.run_bzr(['mkdir', '-p', 'somedir'])
+
+    def test_mkdir_parents_existing_unversioned_dir(self):
+        tree = self.make_branch_and_tree('.')
+        os.mkdir('somedir')
+        self.run_bzr(['mkdir', '-p', 'somedir'])
+        self.assertEquals(tree.kind(tree.path2id('somedir')), "directory")
+
     def test_mkdir_parents_with_unversioned_parent(self):
         tree = self.make_branch_and_tree('.')
         os.mkdir('somedir')

